/*
Copyright 2010, 2012, 2014 Jose Robson Mariano Alves

This file is part of bgfinancas.

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This package is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program. If not, see <http://www.gnu.org/licenses/>.

*/

package Principal;

import Biblioteca.JanelaModal;
import Biblioteca.Janelinha;
import Biblioteca.Secure;
import java.sql.SQLException;


public class Login extends JanelaModal {

    private final TelaPrincipal Principal;
    
    public Login(java.awt.Frame parent, boolean modal, TelaPrincipal Tela) {
        super(parent, modal);
        Principal = Tela;
        initComponents();
    }

    public void Logar()
    {
        mensagem.setText("");
        Banco.executeQuery("SELECT nome FROM usuarios WHERE usuario='"+usuario.getText()+"' AND senha='"+Secure.md5(String.valueOf(senha.getPassword()))+"'");
        try {
            if(Banco.getResultSet().next())
            {
                Principal.setLogado(Banco.getResultSet().getString("nome"));
                Login.this.dispose();
            } else {
                mensagem.setText(Lingua.getMensagem("erro_login"));
            }
        } catch (SQLException ex) {
            Janelinha.Aviso(Lingua.getMensagem("erro"),Lingua.getMensagem("excecao")+" "+ex);
        }
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        javax.swing.JPanel jPanel1 = new javax.swing.JPanel();
        slogan = new javax.swing.JLabel();
        USUARIO = new javax.swing.JLabel();
        SENHA = new javax.swing.JLabel();
        usuario = new javax.swing.JTextField();
        Login = new javax.swing.JButton();
        senha = new javax.swing.JPasswordField();
        mensagem = new javax.swing.JLabel();
        Login1 = new javax.swing.JButton();
        logo = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle(Lingua.getMensagem("sistema"));
        setUndecorated(true);

        jPanel1.setBackground(new java.awt.Color(255, 255, 255));
        jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder(javax.swing.BorderFactory.createTitledBorder("")));
        jPanel1.setCursor(new java.awt.Cursor(java.awt.Cursor.DEFAULT_CURSOR));
        jPanel1.setPreferredSize(new java.awt.Dimension(425, 260));
        jPanel1.setLayout(null);

        slogan.setBackground(new java.awt.Color(0, 0, 0));
        slogan.setFont(FonteFinancasNegrito);
        slogan.setForeground(new java.awt.Color(204, 204, 204));
        slogan.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        slogan.setText(Lingua.getMensagem("gerenciador_despesas"));
        slogan.setEnabled(false);
        slogan.setFocusable(false);
        slogan.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        slogan.setRequestFocusEnabled(false);
        slogan.setVerifyInputWhenFocusTarget(false);
        jPanel1.add(slogan);
        slogan.setBounds(150, 70, 260, 40);

        USUARIO.setFont(FonteFinancas);
        USUARIO.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        USUARIO.setText(Lingua.getMensagem("usuario")+":");
        jPanel1.add(USUARIO);
        USUARIO.setBounds(130, 130, 100, 20);

        SENHA.setFont(FonteFinancas);
        SENHA.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        SENHA.setText(Lingua.getMensagem("senha")+":");
        jPanel1.add(SENHA);
        SENHA.setBounds(130, 160, 100, 20);

        usuario.setFont(FonteFinancas);
        usuario.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                usuarioActionPerformed(evt);
            }
        });
        jPanel1.add(usuario);
        usuario.setBounds(240, 130, 150, 20);

        Login.setFont(FonteFinancas);
        Login.setText(Lingua.getMensagem("entrar"));
        Login.setContentAreaFilled(false);
        Login.setFocusable(false);
        Login.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                LoginActionPerformed(evt);
            }
        });
        jPanel1.add(Login);
        Login.setBounds(240, 190, 80, 30);

        senha.setFont(FonteFinancas);
        senha.setMinimumSize(new java.awt.Dimension(6, 25));
        senha.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                senhaActionPerformed(evt);
            }
        });
        jPanel1.add(senha);
        senha.setBounds(240, 160, 150, 20);

        mensagem.setFont(FonteFinancasPequena);
        mensagem.setForeground(new java.awt.Color(255, 0, 0));
        mensagem.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jPanel1.add(mensagem);
        mensagem.setBounds(180, 230, 240, 30);

        Login1.setFont(FonteFinancas);
        Login1.setText(Lingua.getMensagem("sair"));
        Login1.setContentAreaFilled(false);
        Login1.setFocusable(false);
        Login1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                Login1ActionPerformed(evt);
            }
        });
        jPanel1.add(Login1);
        Login1.setBounds(330, 190, 60, 30);

        logo.setIcon(new javax.swing.ImageIcon(getClass().getResource("/Imagens/layout/login.png"))); // NOI18N
        logo.setBorderPainted(false);
        logo.setContentAreaFilled(false);
        logo.setFocusPainted(false);
        logo.setFocusable(false);
        jPanel1.add(logo);
        logo.setBounds(0, 0, 425, 260);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        );

        setSize(new java.awt.Dimension(425, 260));
        setLocationRelativeTo(null);
    }// </editor-fold>//GEN-END:initComponents

    private void LoginActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_LoginActionPerformed
        Logar();
    }//GEN-LAST:event_LoginActionPerformed

    private void usuarioActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_usuarioActionPerformed
        senha.requestFocus();
    }//GEN-LAST:event_usuarioActionPerformed

    private void senhaActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_senhaActionPerformed
        Logar();
    }//GEN-LAST:event_senhaActionPerformed

    private void Login1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_Login1ActionPerformed
        System.exit(0);
    }//GEN-LAST:event_Login1ActionPerformed

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton Login;
    private javax.swing.JButton Login1;
    private javax.swing.JLabel SENHA;
    private javax.swing.JLabel USUARIO;
    private javax.swing.JButton logo;
    private javax.swing.JLabel mensagem;
    private javax.swing.JPasswordField senha;
    private javax.swing.JLabel slogan;
    private javax.swing.JTextField usuario;
    // End of variables declaration//GEN-END:variables

}
